''***************************************
'' sdserver-Object
''***************************************
{{                                             
        this sdserver-object works with the sdclient-object.

        up to 4 clients can connect to a server.

        each client can have 3 Files open at any time

        the server can provide a common hub area for communication between clients

        communication Server to Client is Fullduplex 8,n,1 with NOMODE (JDcogSerial)

        I simply connect rx of one prop to tx of the other and vice versa ...

        sdserver uses KYE's SD-MMC_FATEngine ... commented out a lot spin thus
        it is included and called SD-MMC_FATEnginea with an a on the end
        i just added

        PUB getCogID 
        RETURN cardCogID -1

        because i allways have this ...
       
        sdserver and sdclient use the PASM from JDCogSerial

        org. JDCogSerial.spin commented out at the end of this file

JDCogSerial.spin :
  V08.07.01 - Initial Release
  V09.01.10 - Added MIT license for OBEX
  v09.03.19 - Fixed some bugs in the spin code
              
It has the following features:
1) The buffer memory is in the cog! The buffers have been set to use the
   maximum amount of cog space. They may be easily changed - see the CON
   section. There are over 1300 bytes of buffer space available.
2) The VAR footprint is tiny - only 6 longs!!!
3) In only supports FullDuplexSerial mode %0000.
4) It supports standard baud rates up to 230400 and non-standard up to above
   345600 (345600 = 115200 * 3).
'''
}}

CON

' internal enums for status of runcmd

  _cmd_ret_err_text_in_str         = 0
  _cmd_ret_ok_nostr_or_key4_byte   = 1
  _cmd_ret_ok_or_parterr_in_tmp    = 2
  _cmd_ret_ok_and_text_in_tmp      = 3
  _cmd_wait_for_bytes_to_write     = 4
  _cmd_ret_number_in_key4          = 5
 
' internal offsets in buffer

  _cmdready = 0                      'flag between addcmd and runcmd
  _idx      = _cmdready + 4 ' 4      'current bufferindex
  _state    = _idx + 4      ' 8      'state of buffer
  _cmdcnt   = _state + 4    ' 12      counts cmds per client
  _rx1_buf  = _cmdcnt + 4   ' 16      rx-Mailbox JDcogSerial
  _tx1_buf  = _rx1_buf + 4  ' 20      tx-Mailbox JDcogSerial
  _rx1_mask = _tx1_buf + 4  ' 24    unused after start
  _tx1_mask = _rx1_mask + 4  ' 28   unused after start
  _baud1_ticks = _tx1_mask + 4 ' 32 unused after start  
  _mempos   = _baud1_ticks + 4   '36  filepos for hub-access
  _eepos    = _mempos + 4    ' 20     filepos for eeprom-acces (unused)
  _cmd      = _eepos + 4    ' 44      current cmd
  _key1     = _cmd          ' 44      first 4 bytes of current cmd
  _key2     = _key1 + 1     ' 45
  _key3     = _key2 + 1     ' 46
  _key4     = _key3 + 1     ' 47
                            '         (some space for parameter of cmds)
  _buf      = _cmd + 16     ' 60      start of the buffer
  _blocklen = _buf + 536    ' 596
                                    
' some internal constants
  
  _BSP                           = $08                    ' backspace
  _CR                            = $0D                    ' carriage return
  _LF                            = $0A                    ' line feed
  _toUpper = "A"-"a"                                      ' value negativ !

' constants from JDcogSerial
'
' The buffer sizes may be freely adjusted. As long as the code still compiles
' to fit into the cog. The sizes are currently at their maximum. The sizes are
' number of longs, so the number of bytes stored is four times as many!

  _RX1FIFO_SIZE = 167    '668 bytes
  _TX1FIFO_SIZE = 168    '672 bytes

OBJ
                          
  SD[12]   : "SD-MMC_FATEnginea"   ' 12 SD-Driver using 1 cog

DAT

cogadd         LONG 0              ' SD-Server uses 2 cogs + 1 per client
cogrun         LONG 0
cogjd1         LONG 0
cogjd2         LONG 0
cogjd3         LONG 0
cogjd4         LONG 0              ' so with 4 Ports 7 cogs are busy...

sOK            BYTE "OK ",0
sERR           BYTE "ER ",0
sDir           BYTE "   <DIR>",0
sNotSupported  BYTE "sorry, not supported",13,0
sErrWrap       BYTE "misc. ERR dir wrap",0
sErrNext       BYTE "misc. ERR dir next",0

VAR

  LONG baseptr                             ' -1 or Adr of shared mem
  LONG cntports                            ' number of active ports 
  BYTE cmdbufT0[_blocklen]                 ' one buffer each port
  BYTE cmdbufT1[_blocklen] 
  BYTE cmdbufT2[_blocklen] 
  BYTE cmdbufT3[_blocklen]
  LONG addcmd_Cog_Stack[100]               'guessed Stack space for add cog 
  LONG runcmd_Cog_Stack[100]               'guessed Stack space for run cog

PUB Stop
'-------------------------------------------------------------------------
'------------------------------+------+-----------------------------------
'------------------------------ Stop -----------------------------------
'------------------------------+------+-----------------------------------
'-------------------------------------------------------------------------
''     Action: Stops Object and COGs                              
'' Parameters: none                                 
''    Results: none                                                              
''+Reads/Uses: SD[12]                                             
''    +Writes: cogadd,cogrun,cogjd1,cogjd2,cogjd3,cogjd4,cntports                                    
'-------------------------------------------------------------------------      
    if cogadd
      COGSTOP(cogadd~ - 1)
    if cogrun                       
      COGSTOP(cogrun~ - 1)
    if cogjd1
      COGSTOP(cogjd1~ - 1)
    if cogjd2
      COGSTOP(cogjd2~ - 1)
    if cogjd3
      COGSTOP(cogjd3~ - 1)
    if cogjd4
      COGSTOP(cogjd4~ - 1)
    \unmountp  
    \SD[0].FATEngineStop 
    cogadd~
    cogrun~
    cntports~
'-------------------------------------------------------------------------
     
PUB Init(commonptr)  
'-------------------------------------------------------------------------
'------------------------------+------+-----------------------------------
'------------------------------ Init -----------------------------------
'------------------------------+------+-----------------------------------
'-------------------------------------------------------------------------
''     Action: sets baseptr and clears buffer                              
'' Parameters: commonptr: base-address of shared hub-area or -1 if none                                
''    Results: none                                                              
''+Reads/Uses:                                              
''    +Writes: baseptr,@cmdbufT...                                    
'-------------------------------------------------------------------------
    Stop
    baseptr:=commonptr
    bytefill(@cmdbufT0,0,_blocklen)
    bytefill(@cmdbufT1,0,_blocklen)
    bytefill(@cmdbufT2,0,_blocklen)
    bytefill(@cmdbufT3,0,_blocklen)
    long[@cmdbufT0+_rx1_buf] := -1                    'Set receiver to idle
    long[@cmdbufT0+_tx1_buf] := -1                    'Set transmitter to idle
    long[@cmdbufT1+_rx1_buf] := -1                    'Set receiver to idle
    long[@cmdbufT1+_tx1_buf] := -1                    'Set transmitter to idle
    long[@cmdbufT2+_rx1_buf] := -1                    'Set receiver to idle
    long[@cmdbufT2+_tx1_buf] := -1                    'Set transmitter to idle
    long[@cmdbufT3+_rx1_buf] := -1                    'Set receiver to idle
    long[@cmdbufT3+_tx1_buf] := -1                    'Set transmitter to idle
'-------------------------------------------------------------------------
 
PUB AddPort(rxpinmask,txpinmask,baudrate)
'-------------------------------------------------------------------------
'------------------------------+---------+--------------------------------
'------------------------------ AddPort --------------------------------
'------------------------------+---------+--------------------------------
'-------------------------------------------------------------------------
''     Action: Starts serial port for sd-client on Server
''             baudrate -1 disabled                           
'' Parameters: rxpinmask,txpinmask,baudrate                                
''    Results: none                                                              
''+Reads/Uses:                                              
''    +Writes: cntports,cogjdX
''       Note: rxpinmask and txpinmask are masks not pinnumbers                                
'-------------------------------------------------------------------------
    if cntports<4
      if baudrate>0
        long[@cogjd1+(cntports*4)]:=JDstart(rxpinmask, txpinmask, baudrate,@cmdbufT0+(cntports*_blocklen)+_rx1_buf)  
        cntports++
'-------------------------------------------------------------------------
  
PUB Start(DOPin, CLKPin, DIPin, CSPin, WPPin, CDPin, RTCReserved1, RTCReserved2, RTCReserved3) 
'-------------------------------------------------------------------------
'------------------------------+-------+----------------------------------
'------------------------------ Start ----------------------------------
'------------------------------+-------+----------------------------------
'-------------------------------------------------------------------------
''     Action: Starts Object and COGs                              
'' Parameters: all parameter from KYS fatEngineStart...                                 
''    Results: >0 if startet                                                              
''+Reads/Uses: SD[12]                                             
''    +Writes: cogadd,cogrun,cogjd1,cogjd2,cogjd3,cogjd4                                    
'-------------------------------------------------------------------------      
    RESULT~
    if SD[0].fatEngineStart(DOPin, CLKPin, DIPin, CSPin, WPPin, CDPin, RTCReserved1, RTCReserved2, RTCReserved3)
      \mountp
        if cogrun:=COGNEW(runcmd_Cog_Loop,@runcmd_Cog_Stack)+1
          RESULT:=cogadd:=COGNEW(addcmd_Cog_Loop,@addcmd_Cog_Stack)+1
'-------------------------------------------------------------------------      
     
PUB getPortCmdCnt(port)                                 ' port 1-4
'-------------------------------------------------------------------------
'------------------------------+---------------+--------------------------
'------------------------------ getPortCmdCnt --------------------------
'------------------------------+---------------+--------------------------
'-------------------------------------------------------------------------
''     Action: Returns running cmdcounter of port. incremented per cmd                              
'' Parameters: port number 1-4                                 
''    Results: cmd count of port                                                              
''+Reads/Uses: @cmdbufTX                                             
''    +Writes: none                                    
'-------------------------------------------------------------------------      
    if port>0
      if (port-1) < cntports
        Result:=long[@cmdbufT0 + ( (port-1) * _blocklen ) + _cmdcnt]
'-------------------------------------------------------------------------      
     
PUB getPort1cogID 
'-------------------------------------------------------------------------
'------------------------------+---------------+--------------------------
'------------------------------ getPort1cogID --------------------------
'------------------------------+---------------+--------------------------
'-------------------------------------------------------------------------
''     Action: returns cogid                              
'' Parameters: none                               
''    Results: cogid of serial port 1 cog                                                              
''+Reads/Uses: cogjd1                                             
''    +Writes: none                                    
'-------------------------------------------------------------------------      
RETURN cogjd1 -1
'-------------------------------------------------------------------------      

PUB getPort2cogID 
'-------------------------------------------------------------------------
'------------------------------+---------------+--------------------------
'------------------------------ getPort2cogID --------------------------
'------------------------------+---------------+--------------------------
'-------------------------------------------------------------------------
''     Action: returns cogid                              
'' Parameters: none                               
''    Results: cogid of serial port 2 cog                                                              
''+Reads/Uses: cogjd2                                             
''    +Writes: none                                    
'-------------------------------------------------------------------------      
RETURN cogjd2 -1
'-------------------------------------------------------------------------      

PUB getPort3cogID 
'-------------------------------------------------------------------------
'------------------------------+---------------+--------------------------
'------------------------------ getPort3cogID --------------------------
'------------------------------+---------------+--------------------------
'-------------------------------------------------------------------------
''     Action: returns cogid                              
'' Parameters: none                               
''    Results: cogid of serial port 3 cog                                                              
''+Reads/Uses: cogjd3                                             
''    +Writes: none                                    
'-------------------------------------------------------------------------      
RETURN cogjd3 -1
'-------------------------------------------------------------------------      

PUB getPort4cogID 
'-------------------------------------------------------------------------
'------------------------------+---------------+--------------------------
'------------------------------ getPort4cogID --------------------------
'------------------------------+---------------+--------------------------
'-------------------------------------------------------------------------
''     Action: returns cogid                              
'' Parameters: none                               
''    Results: cogid of serial port 4 cog                                                              
''+Reads/Uses: cogjd1                                             
''    +Writes: none                                    
'-------------------------------------------------------------------------      
RETURN cogjd4 -1
'-------------------------------------------------------------------------      

PUB getSDcogID 
'-------------------------------------------------------------------------
'------------------------------+------------+-----------------------------
'------------------------------ getSDcogID -----------------------------
'------------------------------+------------+-----------------------------
'-------------------------------------------------------------------------
''     Action: returns cogid                              
'' Parameters: none                               
''    Results: cogid of SD-Card cog                                                              
''+Reads/Uses: cogjd1                                             
''    +Writes: none                                    
'-------------------------------------------------------------------------      
RETURN SD.getCogID
'-------------------------------------------------------------------------      

PUB getADDcogID 
'-------------------------------------------------------------------------
'------------------------------+-------------+----------------------------
'------------------------------ getADDcogID ----------------------------
'------------------------------+-------------+----------------------------
'-------------------------------------------------------------------------
''     Action: returns cogid                              
'' Parameters: none                               
''    Results: cogid of cog adding cmds and moving bytes                                                              
''+Reads/Uses: cogadd                                             
''    +Writes: none                                    
'-------------------------------------------------------------------------      
RETURN cogadd -1
'-------------------------------------------------------------------------      

PUB getRUNcogID 
'-------------------------------------------------------------------------
'------------------------------+-------------+----------------------------
'------------------------------ getRUNcogID ----------------------------
'------------------------------+-------------+----------------------------
'-------------------------------------------------------------------------
''     Action: returns cogid                              
'' Parameters: none                               
''    Results: cogid of cog running cmds on sd-Card                                                              
''+Reads/Uses: cogrun                                             
''    +Writes: none                                    
'-------------------------------------------------------------------------      
RETURN cogrun -1
'-------------------------------------------------------------------------      

PRI mountp | fio 

''' mount all driver ... eat errors

   \SD[0].mountPartition(0)
   if SD[0].partitionMounted
      repeat fio from 1 to 11
         \SD[fio].mountPartition(0)
     
PRI unmountp | fio

''' unmount all driver ... should eat error ?

   if(SD[0].partitionMounted)
      \SD[0].closeFile
      \sd[0].unmountPartition
      repeat fio from 1 to 11 
        if(SD[fio].partitionMounted)
           \SD[fio].closeFile
           \SD[fio].unmountPartition

PRI openf(port,idx,Mode,buf) | err,ern

''' opens a file. eats error "entry_already_exist" on open for write
''' returns 0 or pointer to errorstring for all other errors

   RESULT~
   if Mode<>"R"
      err := \sd[idx].newFile(buf+_key4)
      ern :=  sd[idx].partitionError ' Returns zero if no error occurred.
      if(ern) ' Try to handle the "entry_already_exist" error.
         if(ern == sd#Entry_Already_Exist)
            if Mode=="W"
   '           Re-create the file.
               sd[idx].deleteEntry(buf+_key4)
               sd[idx].newFile(buf+_key4)
      
   err:=\sd[idx].openFile(buf+_key4,Mode)
   if sd[idx].partitionerror
      RESULT:=err
   
PRI readDec(strptr) | num,idx

''' Returns decimal number from string strptr if any there else 0

   RESULT~
   idx:= strsize(strptr)
   repeat idx 
      num:=byte[strptr++]
      if ((num>47) and (num<58))
         RESULT:=(RESULT * 10) + num-48

PRI JDstart(rxpinmask, txpinmask, baudrate, addr) 
  'rx1_buf
  long[addr] := -1                    'Set receiver to idle
  'tx1_buf
  long[addr+4] := -1                    'Set transmitter to idle
  'rx1_mask
  long[addr+8] := rxpinmask             'Set receive pinmask
  'tx1_mask
  long[addr+12] := txpinmask             'Set transmit pinmask
  'baud1_ticks
  long[addr+16] := CLKFREQ / baudrate    'Set baudrate
  RESULT:= cognew(@JDentry, addr) + 1    'Start the cog

PRI rxcheck(port) | rxptr

{ Check if byte received (never waits)
  returns < 0 if no byte received, $00..$FF if byte }
  
  rxptr:= @cmdbufT0 + ( port * _blocklen ) + _rx1_buf   
  if (RESULT := long[rxptr]) => 0
    long[rxptr] := -1
     

PRI txcheck(port) : retZeroSendOK | txptr
 
{ test if send is possible WARNING returns -1 if NO and 0 if YES like rxcheck }

  retZeroSendOK~~
  txptr:= @cmdbufT0 + ( port * _blocklen ) + _tx1_buf  
  if (long[txptr] < 0)
     retZeroSendOK :=0
     
PRI tx(port,txbyte) | txptr
 
{ Send byte (may wait for room in buffer) }

  txptr:= @cmdbufT0 + ( port * _blocklen ) + _tx1_buf
  repeat while long[txptr] => 0
  long[txptr] := txbyte

PRI txOut(where, value)

''' Print byte value
''' Output goes to serial port #where if where < 4 else into hubmem at adr where
''' Returns where if where < 4 else incremented hubmem adr.

   RESULT:=where
   case where
      0..3:                                             ' ser. Term
         tx(where,value)                               
      other:                                             ' Adress
         byte[RESULT++]:=value
           
PRI txWrite(where,hubptr,numbytes) | key

''' Print #numbytes bytes starting from hubptr
''' uses txOut(where,value) for output so:
''' Output goes to serial port #where if where < 4 else into hubmem at adr where
''' Returns where if where < 4 else incremented hubmem adr.

   RESULT:=where
   case where
      0..3:
         repeat numbytes
            tx(where,byte[hubptr++])
      other:
         repeat numbytes
           byte[RESULT++]:=byte[hubptr++]
   
PRI txStr(where,strptr) | bytes

''' Print a string
''' uses txOut(where,value) for output so:
''' Output goes to serial port #where if where < 4 else into hubmem at adr where
''' Returns where if where < 4 else incremented hubmem adr.

   bytes:=strsize(strptr)
   RESULT:= txWrite(where,strptr,bytes)

PRI txDec(where, value, digits) | mindigits, val, resu, i

''' Print a decimal number.
''' if digits 0 just like it is.
''' if digits  > 0 right-justified with leading spaces in a field width given by digits. 
''' if digits  < 0 right-justified with leading zeros in a field width given by (-)digits. 
''' uses txOut(where,value) for output so:
''' Output goes to serial port #where if where < 4 else into hubmem at adr where
''' Returns where if where < 4 else incremented hubmem adr.

   RESULT:=where
   if digits<>0
      mindigits := ((value < 0) & 1) + 1
      if (value <> $8000_0000)
         val := || value
         repeat while (val /= 10)
            mindigits++
      if (value < 0 and digits < 0)
         RESULT:=txOut(RESULT,"-")
   '      value := ||value
      repeat (||digits - mindigits) #> 0
         if (digits < 0) 
             RESULT:=txOut(RESULT,"0")
         else
             RESULT:=txOut(RESULT," ")
              
   resu:=0
   RESULT:=where
   if value < 0
      -value
      RESULT:=txOut(RESULT,"-")

   i := 1_000_000_000

   repeat 10
      if value => i
         RESULT:=txOut(RESULT,value / i + "0")
         value //= i
         resu~~
      elseif resu or i == 1
         RESULT:=txOut(RESULT,"0")
      i /= 10   
 
PRI runcmd_Cog_Loop | port, buf,status,idx,key1,key2,key3,key4,str,tmp,fidx

''' this spin cog loops thru all clients and executes cmds to sd-drivers

    port:=cntports
    repeat
        port++
        if not (port<cntports)
           port:=0
     
        buf:=@cmdbufT0 + ( port * _blocklen )
        
        if long[buf+_cmdready]>0                              ' else busy with addcmd
         
            status:=_cmd_ret_err_text_in_str                  ' Preset with error (0)
            idx:=long[buf+_idx]
            if idx>0                                          ' something in cmd-buffer ? 
          
               key1:=byte[buf+_key1]                          ' get cmdbytes
               key2:=byte[buf+_key2] 
               key3:=byte[buf+_key3]
               key4:=byte[buf+_key4]
          
               if key1>"Z"                                    ' First 2 cmdbytes to uppercase
                  key1+=_toUpper
               if key2>"Z"
                  key2+=_toUpper
                  
               str~                                           ' clear tmp-pointer
               tmp~
               
               case key1                                      ' decode cmd !
          
               '   AX - CX File Operations
                  "A".."C":
                     fidx:=port+(key1-"A")*4                   ' index for SD-object                   
                     case key2
                        "A":                                  ' XA PathFile : FILE X Open Append 
                            if (key3==" ")
                               str:=openf(port,fidx,"A",buf)
                               if str==0                      ' else     status 0 : str is errmessage 
                                  tmp:=\sd[fidx].fileTell     '                  get FilePos
                                  if sd[fidx].partitionerror
                                     str:=tmp                 '          status 0 : str is errmessage
                                  else
                                     key4:=tmp                '          status 5 : key4 is Number to Return (FilePos)
                                     status:=_cmd_ret_number_in_key4 'XA PathFile : FILE X Open Append returns FilePos
                               
                        "B":                                  ' XB Path     : DIR X Open
                           if (key3==" ")
                              tmp:=\sd[fidx].changeDirectory(buf+_key4)
                              if sd[fidx].partitionerror
                                 str:=tmp                     '          status 0 : str is errmessage
                              else
                                 tmp:= \sd[fidx].listEntries("W")
                                 if sd[fidx].partitionerror
                                    str:=@sErrWrap                '      status 0 : str is errmessage
                                 else
                                    key4:=0
                                    status:=_cmd_ret_number_in_key4    ' XB Path     : DIR X Open
                        "C":                                  ' XC          : FILE X Close               ' 
                            tmp:=\sd[fidx].closeFile
                            status:=_cmd_ret_ok_or_parterr_in_tmp ' XC          : FILE X Close
                            
                        "D":                                  ' XD PathEntry :FILE X Delete (File or Dir)
                           if (key3==" ")
                              tmp:= \sd[fidx].deleteEntry(buf+_key4)
                              status:=_cmd_ret_ok_or_parterr_in_tmp ' XD           :FILE X Delete
          
                        "E":                                  ' XE          : DIR/File X Size
                            if (sd[fidx].listIsDirectory)
                               key4~~
                            else
                               key4:=sd[fidx].listSize
                            status:=_cmd_ret_number_in_key4   ' XE          : DIR/File X Size
                           
                        "F":                                  ' XF          : FILE X Flush
                            tmp:=\sd[fidx].flushData
                            status:=_cmd_ret_ok_or_parterr_in_tmp ' XF          : FILE X Flush 
                         
                        "G":                                  ' XG 001-512  : FILE X Get DecCnt
                            key4:=ReadDec(buf+_key4)
                            if key4>0 and key4<513            ' last 512 Buffer
                               str:=buf+_buf
                               tmp:=\sd[fidx].readData(str,key4)
                               if sd[fidx].partitionerror
                                  str:=tmp
                               else
                                  key4:=tmp                   ' adresse buf+16 .... key4 bytes
                                  str:=buf+_buf
                                  status:=_cmd_ret_ok_nostr_or_key4_byte ' XG          : FILE X Get
                                       ' 
                        "K":                                  ' DA Path      : Dir Add  NewDir
                           if (key3==" ")
                              tmp:=\sd[port].newDirectory(buf+_key4)
                              if sd[port].partitionerror
                                 str:=tmp 
                              else
                                 status:=_cmd_ret_ok_and_text_in_tmp ' DA Path:Dir Add  NewDir                     
                        "M":                                  ' DM           : Dir Next / More Info
                           tmp:= \sd[fidx].listEntries("N")
                           if sd[port].partitionerror
                              str:=@sErrNext
                           else
                              str:=buf+_buf
                                        
                              str:=txStr(str,tmp)         
                              if (sd[fidx].listIsDirectory)
                                 str:=txStr(str,@sDir)
                              else
                                 str:=txDec(str,sd[fidx].listSize,8)
                              key4:=str-(buf+_buf)            ' adresse buf+20 .... key4 bytes
                              str:=buf+_buf                   
                              status:=_cmd_ret_ok_nostr_or_key4_byte 'DM:Dir Next / More Info

                        "N":                                  ' XN : Dir Next
                            tmp:= \sd[fidx].listEntries("N")
                            if sd[fidx].partitionerror
                               str:=@sErrNext
                            else
                               status:=_cmd_ret_ok_and_text_in_tmp ' XN : Dir Next
          
                        "P":                                  ' XP 001-512  : FILE X Put DecCnt               ' 
                            key4:=ReadDec(buf+_key4)
                            if key4>0 and key4<513
                               if idx==(key4+_buf)            ' all received to write ?
                                  tmp:=\sd[fidx].writeData(buf+_buf,key4) ' yes write
                                  status:=_cmd_ret_ok_or_parterr_in_tmp
                               else                           '             no wait for bytes
                                  status:=_cmd_wait_for_bytes_to_write ' XP : FILE X Put
                         
                        "R":                                  ' XR PathFile : FILE X Open Read               ' 
                            if (key3==" ")
                               str:=openf(port,fidx,"R",buf)
                               if str==0
                                  key4:=0
                                  status:=_cmd_ret_number_in_key4 ' XR PathFile : FILE X Open Read  returns FilePos(0)
                            
                        "S":                                  ' XS DecPos   : FILE X Seek DecPos               ' 
                            key4:=ReadDec(buf+_key4)
                            tmp:=\sd[fidx].fileSeek(key4)
                            if sd[fidx].partitionerror
                               str:=tmp
                            else
                               key4:=tmp
                               status:=_cmd_ret_number_in_key4 ' XS         : FILE X Seek  returns FilePos
          
                        "T":                                  ' XT          : FILE X Tell
                            tmp:=\sd[fidx].fileTell
                            if sd[fidx].partitionerror
                               str:=tmp
                            else
                               key4:=tmp
                               status:=_cmd_ret_number_in_key4                      ' XT          : FILE X Tell  returns FilePos
          
                        "W":                                  ' XW PathFile : FILE X Open Write               ' 
                            if (key3==" ")
                               str:=openf(port,fidx,"W",buf)
                               if str==0
                                  key4:=0
                                  status:=_cmd_ret_number_in_key4 ' XW PathFile : FILE X Open Write  returns FilePos
                  
                   ' H HUB Operation Server Seek Get Put 
                  "H":
                     if baseptr>-1
                        case key2
                           "G":                                 ' HG 001-512  : HUB Get DecCnt
                               key4:=ReadDec(buf+_key4)
                               if key4>0 and key4<513            ' last 512 Buffer
                                  str:=buf+_buf
                                  bytemove(str,baseptr+long[buf+_mempos],key4) ' Read HUB
                                  long[buf+_mempos]:=long[buf+_mempos]+key4
                                  str:=buf+_buf
                                  status:=_cmd_ret_ok_nostr_or_key4_byte ' HG  : HUB Get
                               
                           "P":                                  ' HP 001-512  : HUB Put DecCnt               ' 
                               key4:=ReadDec(buf+_key4)
                               if key4>0 and key4<513
                                  if idx==(key4+_buf)            ' all received to write ?
                                     bytemove(baseptr+long[buf+_mempos],buf+_buf,key4) ' Write HUB
                                     long[buf+_mempos]:=long[buf+_mempos]+key4
                                     status:=_cmd_ret_ok_or_parterr_in_tmp
                                  else                           '             no wait for bytes
                                     status:=_cmd_wait_for_bytes_to_write ' HP : HUB Put
                         
                           "S":                                   ' HS DecPos    : HUB Seek DecPos               ' 
                               key4:=ReadDec(buf+_key4)
                               long[buf+_mempos]:=key4
                               status:=_cmd_ret_number_in_key4   ' HS          : HUB Seek  returns memPos

                           "T":                                  ' HT          : HUB Tell
                               key4:=long[buf+_mempos]
                               status:=_cmd_ret_number_in_key4   ' HT          : HUB Tell  returns FilePos
          
                   ' Server-Client-Info 
                  "V":
                     case key2
                        "I":                                     ' VI get own Clientid 
                           key4:=port+1
                           status:=_cmd_ret_number_in_key4
                        "V":                                      ' Partition Label
                           tmp:=sd[port].partitionVolumeLabel
                           status:=_cmd_ret_ok_and_text_in_tmp 
                  
               if status==_cmd_ret_number_in_key4
                  str:=buf+_buf
                  key4:=txDec(str,key4,0)                        ' copy num to str
                  key4:=key4-str
                  status:=_cmd_ret_ok_nostr_or_key4_byte         ' OK + Text
               elseif status==_cmd_wait_for_bytes_to_write
                  if idx<_buf                     '              ' init transfer
                     idx:=_buf
                     long[buf+_idx]:=_buf                        ' set startpos
                     status:=-key4                               ' status neg: Bytes to read
                  else
                     status:=long[buf+_state]                    ' leave old status ... wait
               elseif status==_cmd_ret_ok_and_text_in_tmp
                  key4:=strsize(tmp)                             ' adresse buf+_buf key4 bytes
                  str:=buf+_buf
                  txStr(str,tmp)                                 ' copy tmp to str
                  str:=buf+_buf                                  ' set flag
                  status:=_cmd_ret_ok_nostr_or_key4_byte         ' OK + Text               
               elseif status==_cmd_ret_ok_or_parterr_in_tmp
                  if sd[fidx].partitionerror                     ' If partitionerror
                     str:=tmp
                     status:=_cmd_ret_err_text_in_str            '      output err          
                  else
                     status:=_cmd_ret_ok_nostr_or_key4_byte      ' else OK                
          
               case status                                       ' If none of this just return status as is
                  _cmd_ret_err_text_in_str:                      ' 0 Error !
                     byte[buf+_buf-1]:=0
                     if str==0                                   ' if no Errormessage there
                        str:=@sNotSupported                      '    give generic one
                     txStr(port,@sERR)                            ' send Error-Indicator
                     txDec(port,strsize(str),0)                   ' send Stringsize Error-String + CR
                     txOut(port,_CR)
                     txStr(port,str)                              ' send Errorstring
                     long[buf+_idx]~                             ' Ready for new cmd
          
                  _cmd_ret_ok_nostr_or_key4_byte:
                     byte[buf+_buf-1]:=0                         ' OK !
                     txStr(port,@sOK)                             ' send OK-Indicator
                     if str==0                                   ' if nothing to return
                        txOut(port,"0")                           '       state so and end cmd
                        txOut(port,_CR)
                        long[buf+_idx]~
                        status~
                     else                                        ' else str is flag and points to to _buf (see above)
                        txDec(port,key4,0)                        '       send number of bytes to return + CR
                        txOut(port,_CR)
                        if key4==0                               '       if none end cmd
                           long[buf+_idx]~
                           status~
                        else                                     '       else
                           long[buf+_idx]:=_buf                       '               set Pointer to Bytes (starting at _buf)
                           status:=key4                          '               set Bytes to send
               
            long[buf+_cmdcnt]++                                   ' just count number of commands
            long[buf+_state]:=status                             ' Return status
            long[buf+_cmdready]~                                 ' declare finished
                 

PRI addcmd_Cog_Loop | port, buf, retVal, idx, iout,key, bytes

''' this spin-cog listens to the serial ports of JDcogSerial and
''' moves bytes from and to sd-buffer and ports

''' this is supposed to move to pasm

    port:=cntports
    repeat
        port++
        if not (port<cntports)
           port:=0

        buf:=@cmdbufT0 + ( port * _blocklen )

        if long[buf+_cmdready]==0               '  else busy with runcmd
           retVal~
           idx:=long[buf+_idx]
           iout:=long[buf+_state]   
           if iout>0                             ' still need to send bytes of last cmd ?
              bytes:=iout
              if bytes>32                        ' try to send 32 of them
                 bytes:=32
              repeat bytes   
                 key:=txCheck(port)              ' TX Test if send possible
                 if key==0                      
                    txOut(port,byte[buf+idx])     ' send !
                    idx++
                    iout--
                    long[buf+_state]:=iout        ' save state
                    if iout==0
                       idx~
           else
              
              if iout<0                      ' write in Buffer (still reading bytes of last cmd)
            
                 bytes:=-iout
                 if bytes>32                        ' try to read 32 max
                    bytes:=32
                 repeat bytes   
                    if retVal==0
                       key:=RxCheck(port)           ' RX check Key
                       if key>-1                   ' 
                          byte[buf+idx]:=key
                          key~~                       ' eat key
                          idx++
                          iout++
                          long[buf+_state]:=iout
                          if iout==0               ' all bytes of last cmd read
                             retVal:=1             ' cmd now really ready to process
                    
            
              else
                         
                 key:=RxCheck(port)           ' TX check Key
                 if key>-1                       ' else write new cmd
                   if key==_BSP                   
                      if idx>0
                         idx--
                   else
                      if idx<(_blocklen-_cmd)
                         byte[buf+idx+_cmd]:=key
                         idx++
             
                   if (key==_CR) or (key==_LF)
                      byte[buf+idx+_cmd-1]~
                      retval:=1                 ' cmd ready to process
            
           long[buf+_idx]:=idx
           long[buf+_cmdready]:=retval

'
' I am inlining this because I want to move my spin-addcmd loop to pasm

'
DAT
                    ORG     0
'
' PASM from JDcogSerial .... org. SPIN follows as comment...  
'
JDentry             mov     t1,PAR
                    mov     t2,#5
:en1                mov     rx1ptr,t1
                    add     :en1,c512
                    add     t1,#4
                    djnz    t2,#:en1
                    mov     t2,#3
:en2                rdlong  rx1mask,rx1mask
                    add     :en2,c513
                    djnz    t2,#:en2
                    or      OUTA,tx1mask
                    or      DIRA,tx1mask
                    jmp     dRx1

c512                long    512
c513                long    513
                    
rx1ptr              long    0    
tx1ptr              long    0 
rx1mask             long    0
tx1mask             long    0
baud1               long    0
'
' Receiver 
'
aRx1_Start          mov     rx1bits,#9          '# of bits to receive
                    mov     rx1cnt,baud1
                    shr     rx1cnt,#2           'quarter of a bit tick ...
                    add     rx1cnt,baud1        '... plus a full bit tick
                    mov     dRx1,#aRx1_Wait
                    
aRx1_Wait           test    rx1mask, INA  WC    'Wait for start bit
    if_c            jmp     #aRx1_Get                                 
                    add     rx1cnt, CNT
                    mov     dRx1,#aRx1_Bits
                    
aRx1_Bits           mov     t1,rx1cnt           'Check if bit receive period done
                    sub     t1,cnt
                    cmps    t1,#0         WC    'Time to sample yet?
    if_nc           jmp     #aRx1_Get
                    test    rx1mask, INA  WC    'Receive bit into carry
                    rcr     rx1data,#1          'Carry into Rx buffer
                    add     rx1cnt,baud1        'Go to next bit period
                    djnz    rx1bits,#aRx1_Bits  'Get next bit
    if_nc           jmp     #aRx1_Start
                    and     rx1data,cRxAnd      'Mask out the unwanted bits
                    rol     rx1data,rx1rol      'Put the data into the correct byte
                    mov     dRx1,#aRx1_Put
                    jmp     dTx1                'Go do some transmitter code

                    'General variables for the receiver
cRxAnd              long    %0111_1111_1000_0000_0000_0000_0000_0000
rx1len              long    0
rx1maxlen           long    (tx1fifo - rx1fifo - 1) * 4
dRx1                long    aRx1_Start
                    'Variables used to receive a byte into the FIFO
rx1data             long    0
rx1bits             long    0
rx1cnt              long    0
rx1rol              long    9
rx1out              long    0
rx1put              long    rx1fifo
rx1putb             long    $80
                    'Variables used to grab a byte from the FIFO
rx1ror              long    0                    
rx1get              long    rx1fifo
rx1getb             long    $80

aRx1_Put            cmp     rx1len,rx1maxlen  WZ
    if_z            jmp     #(aRx1_Get+2)
                    mov     dRx1,#aRx1_Start
                    add     rx1len,#1
                    or      rx1out,rx1data      'Merge in the new data byte
arp1                mov     rx1fifo,rx1out      'Write to the FIFO memory
                    add     rx1rol,#8           'Prapare for the next byte
                    rol     rx1putb,#8  WC      'C true every 4 cycles
    if_nc           jmp     dTx1
                    add     rx1put,#1
                    cmp     rx1put,#tx1fifo   WZ
    if_z            mov     rx1put,#rx1fifo
                    movd    arp1,rx1put         'Set the new FIFO destination 
                    mov     rx1out,#0
                    jmp     dTx1

aRx1_Get            cmp     rx1len,#0  WZ
    if_z            jmp     dTx1
                    rdlong  t1,rx1ptr
                    shl     t1,#1    WC         'Is the receive buffer empty?
    if_nc           jmp     dTx1                'Jump if not
                    sub     rx1len,#1
arg1                mov     t1,rx1fifo
                    ror     t1,rx1ror
                    and     t1,#$ff
                    wrlong  t1,rx1ptr 
                    add     rx1ror,#8
                    rol     rx1getb,#8  WC      'C true every 4 cycles
    if_nc           jmp     dTx1
                    add     rx1get,#1
                    cmp     rx1get,#tx1fifo  WZ
    if_z            mov     rx1get,#rx1fifo
                    movs    arg1,rx1get
                    jmp     dTx1
'
' Transmitter 
'
aTx1_Start          cmp     tx1len,#0   WZ
    if_z            jmp     #aTx1_Put
                    mov     dTx1,#aTx1_Byte
                    sub     tx1len,#1
atg1                mov     tx1data,tx1fifo
                    ror     tx1data,tx1ror
                    and     tx1data,#$ff
                    add     tx1ror,#8
                    rol     tx1getb,#8  WC
    if_nc           jmp     dRx1     
                    add     tx1get,#1
                    cmp     tx1get,#fifo1end  WZ
    if_z            mov     tx1get,#tx1fifo
                    movs    atg1,tx1get
                    jmp     dRx1

aTx1_Byte           shl     tx1data,#2
                    or      tx1data,cFixedBits  'or in a idle line state and a start bit
                    mov     tx1bits,#11
                    mov     tx1cnt,cnt
aTx1_Bits           shr     tx1data,#1   WC
                    muxc    OUTA,tx1mask        
                    add     tx1cnt,baud1        'Bit period counter
                    mov     dTx1,#aTx1_Wait
                    jmp     dRx1

aTx1_Wait           mov     t1,tx1cnt           'Check bit period
                    sub     t1,CNT
                    cmps    t1,#0       WC      'Is bit period done yet?
    if_nc           jmp     #aTx1_Put
                    djnz    tx1bits,#aTx1_Bits  'Transmit next bit
                    mov     dTx1,#aTx1_Start
                    jmp     dRx1

aTx1_Put            cmp     tx1len,#(fifo1end-tx1fifo) WZ
    if_z            jmp     dRx1
                    rdlong  t1,tx1ptr
                    shl     t1,#1    NR, WC
    if_c            jmp     dRx1
                    wrlong  cMinusOne,tx1ptr
                    add     tx1len,#1
                    and     t1,#$ff
                    shl     t1,tx1rol
                    add     tx1rol,#8
                    or      tx1out,t1
atp1                mov     tx1fifo,tx1out    
                    rol     tx1putb,#8  WC
    if_nc           jmp     dRx1
                    add     tx1put,#1
                    cmp     tx1put,#fifo1end  WZ
    if_z            mov     tx1put,#tx1fifo
                    movd    atp1,tx1put
                    mov     tx1out,#0
                    jmp     dRx1
         
                    'General variables for the transmitter
tx1len              long    0
tx1maxlen           long    (fifo1end - tx1fifo - 1) * 4
dTx1                long    aTx1_Start
                    'Variables used to grab the transmit a byte from the FIFO
tx1data             long    0
tx1bits             long    0
tx1cnt              long    0
tx1ror              long    0
tx1get              long    tx1fifo
tx1getb             long    $80
                    'Variables used to receive a byte into the FIFO
tx1rol              long    0
tx1put              long    tx1fifo
tx1putb             long    $80
tx1out              long    0

'
' Data
'
cFixedBits          long    %1_0000_0000_0_1    'Stop + 8 x Data + Start + Idle bits
cMinusOne           long    -1     

t1                  long    0
t2                  long    0

'
' The buffer sizes may be freely adjusted. As long as the code still compiles
' into the cog. The sizes are currently at their maximum, but may be adjusted
' to favour either the receiver or tranmitter.
'
rx1fifo             res     _RX1FIFO_SIZE
tx1fifo             res     _TX1FIFO_SIZE
fifo1end

                    FIT     496

'
{{
JDCogSerial.spin :
  V08.07.01 - Initial Release
  V09.01.10 - Added MIT license for OBEX
  v09.03.19 - Fixed some bugs in the spin code
              
It has the following features:
1) The buffer memory is in the cog! The buffers have been set to use the
   maximum amount of cog space. They may be easily changed - see the CON
   section. There are over 1300 bytes of buffer space available.
2) The VAR footprint is tiny - only 6 longs!!!
3) In only supports FullDuplexSerial mode %0000.
4) It supports standard baud rates up to 230400 and non-standard up to above
   345600 (345600 = 115200 * 3).
5) The nature of the object allows easy use of the object from other
   modules. For Example:
   --------------------------------------------------------------------
     JDCogSerialDemo.spin                                              
   --------------------------------------------------------------------
   CON                                                                 
     _clkmode      = xtal1 + pll16x                                    
     _xinfreq      = 5_000_000
                                                                                                                     
     BaudRate      = 38400                                             
     RxPin         = |<31                                              
     TxPin         = |<30                                              
                                                                       
   OBJ                                                                 
     Comms : "JDCogSerial"                                             
     Sub : "SubObject"                                                 
                                                                       
   VAR                                                                 
     long CommPtr                                                      
                                                                       
   PUB Start                                                           
     CommPtr := Comms.start(RxPin, TxPin, BaudRate)                    
     if CommPtr then                                                   
       Sub.Init(CommPtr)                                               
       Sub.SendGreeting
                                        
   --------------------------------------------------------------------
     SubObject.spin                                                    
   --------------------------------------------------------------------
   VAR                                                                 
     long RxPtr, TxPtr                                                 
                                                                       
   PUB Init(CommPtr)                                                   
     RxPtr := CommPtr                                                  
     TxPtr := CommPtr + 4                                              
                                                                       
   PUB Rx : RxByte                                                     
     repeat while (RxByte := long[RxPtr]) < 0                          
     long[RxPtr] := -1                                                 
                                                                       
   PUB Tx(TxByte)                                                      
     repeat while long[TxPtr] => 0                                     
     long[TxPtr] := TxByte                                             
                                                                       
   PUB Str(StringPtr)                                                  
     repeat strsize(StringPtr)                                         
       Tx(byte[StringPtr++])                                           
                                                                       
   PUB SendGreeting                                                    
     Str(string("Hello",13,10))
                                             
   --------------------------------------------------------------------
     Read and Write a byte using PASM                 
   --------------------------------------------------------------------
   ' Receive a byte into rx                                            
   aRx      rdlong  rx,RxPtr        'Check the receiver                                   
            shl     rx,#1  WC       'Carry set if no byte available       
     if_c   jmp     #aRx            'Wait for a byte to be received                                   
            wrlong  MinusOne,RxPtr  'Mark the byte as having been read                                     
            ...
   RxPtr    long    0               'Initialized in spin or at cog start                                                           
   rx       long    0
   MinusOne long    -1
                      
                                                                       
   ' Transmit a byte from tx, also need a temporary variable         
   aTx      rdlong  temp,TxPtr      'Check the transmitter                                   
            shl     temp,#1  WC     'Carry set if transmitter is idle     
     if_nc  jmp     #aTx            'Wait til the transmitter is idle                                   
            wrlong  tx,TxPtr        'Write the byte into the transmitter                                   
            ...                                                        
   TxPtr    long    0               'Initialized in spin or at cog start                                                           
   tx       long    0                                                  
   temp     long    0
   --------------------------------------------------------------------
    JDCogSerial.Spin
   --------------------------------------------------------------------

CON                                                                     
' The buffer sizes may be freely adjusted. As long as the code still compiles
' to fit into the cog. The sizes are currently at their maximum. The sizes are
' number of longs, so the number of bytes stored is four times as many!

  RX1FIFO_SIZE = 167    '668 bytes
  TX1FIFO_SIZE = 168    '672 bytes
  
                                               
VAR
  long JDcog                             'cog flag/id

  long rx1_buf                         '5 longs
  long tx1_buf
  long rx1_mask
  long tx1_mask
  long baud1_ticks
  

PUB JDstart(rxpin, txpin, baudrate) : addr
{
  +---------------------------------------------------------------------+
  Purpose:                                                             
    Start a single port serial driver - uses a single cog.             
  +---------------------------------------------------------------------           
  Inputs:                                                              
    rxpin and txpin are passed in as pin masks. The transmitter        
      may be disabled by passing in a mask of 0. The receiver may be   
      disabled by simply ignoring it.                                  
    baudrate etc Is passed in as the desired baudrate. The transmit    
      / receive pair operate at the same baudrate.                     
  +---------------------------------------------------------------------           
  Output:                                                              
    Returns the address of the shared memory space if a cog was        
    successfully started, or 0 if no cog available.                    
  +---------------------------------------------------------------------+
}
  JDStop
  rx1_buf     := -1                    'Set receiver to idle
  tx1_buf     := -1                    'Set transmitter to idle
  rx1_mask    := rxpin                 'Set receive pin
  tx1_mask    := txpin                 'Set transmit pin
  baud1_ticks := CLKFREQ / baudrate    'Set baudrate
  JDcog := cognew(@JDentry, @rx1_buf) + 1  'Start the cog
  if JDcog
    addr := @rx1_buf
    

PUB JDStop
{ Stop serial driver - frees the cog that was used }
  if JDcog
    cogstop(JDcog~ - 1)


PUB rxflush
{ Flush receive buffer }
  repeat until rxcheck < 0

PUB rxcheck : rxbyte
{ Check if byte received (never waits)
  returns < 0 if no byte received, $00..$FF if byte }
  if (rxbyte := rx1_buf) => 0
    rx1_buf := -1

PUB rxtime(ms) : rxbyte | t
{ Wait ms milliseconds for a byte to be received
  returns -1 if no byte received, $00..$FF if byte }
  t := cnt
  repeat until (rxbyte := rxcheck) => 0 or (cnt - t) / (clkfreq / 1000) > ms

PUB rx : rxbyte
{ Receive byte (may wait for byte)
  returns $00..$FF }
  repeat while (rxbyte := rx1_buf) < 0
  rx1_buf := -1

PUB txcheck
    if tx1_buf=>0
       result~~
         
PUB tx(txbyte)
{ Send byte (may wait for room in buffer) }
  repeat while tx1_buf => 0
  tx1_buf := txbyte

PUB str(stringptr)
{ Send a string }
  repeat strsize(stringptr)
    tx(byte[stringptr++])

PUB dec(value) | i

'' Print a decimal number

  if value < 0
    -value
    tx("-")

  i := 1_000_000_000

  repeat 10
    if value => i
      tx(value / i + "0")
      value //= i
      result~~
    elseif result or i == 1
      tx("0")
    i /= 10
}}

{{
+------------------------------------------------------------------------+
                        TERMS OF USE: MIT License                                                                                   
+------------------------------------------------------------------------
  Permission is hereby granted, free of charge, to any person obtaining 
 a copy of this software and associated documentation files (the         
 "Software"), to deal in the Software without restriction, including    
 without limitation the rights to use, copy, modify, merge, publish,    
 distribute, sublicense, and/or sell copies of the Software, and to     
 permit persons to whom the Software is furnished to do so, subject to  
 the following conditions:                                              
                                                                        
  The above copyright notice and this permission notice shall be        
 included in all copies or substantial portions of the Software.          
                                                                        
  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND        
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF     
 MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY   
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,   
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE      
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                 
+------------------------------------------------------------------------+
}}                      